/*
 * title : liss.c  -  X programming example
 * begin : 1999/09/21
 * make  : gcc liss.c -o liss -lm -I/usr/X11R6/include -L/usr/X11R6/lib -lX11
 * note  : modified version on 2002/05/13
 */

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <string.h>
#include <stdio.h>
#include <math.h>

/*  ɥ礭  */
#define  WIN_WIDTH  400
#define  WIN_HEIGHT 400
/*  ɸθĿ  */
#define POINT_MAX  600
/*  ꥵ塼޷κɸݻ  */
XPoint  lj[POINT_MAX];

/*  ޷ɽԤ  */
void draw(Display *d, Window w, GC g)
{
  int  i;
  XClearWindow(d, w);
  XDrawLines(d, w, g, lj, POINT_MAX, CoordModeOrigin);
}

/*  ˺ɸ޷Υѥ᥿򹹿  */
int make_points(double kx, double ky)
{
  int  i;
  double  t;
  for (i = 0; i < POINT_MAX; i++) {
    t = (double) i * 2 * M_PI / (POINT_MAX);
    lj[i].x =  cos(kx * t) * WIN_WIDTH/2*0.9 + WIN_WIDTH/2;
    lj[i].y = -sin(ky * t) * WIN_HEIGHT/2*0.9 + WIN_HEIGHT/2; 
  }
}


int main(int argc, char *argv[])
{
  Display  *d;
  Window  w;
  GC  g;
  XEvent  e;
  /*  ư  */
  double  kx = 0, ky = 0;
  /*    */
  double  range = 1.0;
  int  idx = 1;

  /* ޥɥ饤󤫤ѥ᥿ */
  while (idx < argc) {
    /* إɽ */
    if (strcmp(argv[idx], "-h") == 0) {
      fprintf(stderr, "*** Lissajous curve viewer\n");
      fprintf(stderr, "Usage : %s <range factor>\n", argv[0]);
      fprintf(stderr, "options as follows:\n");
      fprintf(stderr, "  [-h]\n");
      fprintf(stderr, "see document for more informations, thanks.\n");
      exit(1);
    } else
    /* ѥ᥿ */
      sscanf(argv[idx], "%lf", &range);
    idx++;
  }

  if (abs(range) <= 0.01) range = 1.0;
  printf("%g\n", range);
  make_points(kx, ky);

  /*  ɥߤ  */
  d = XOpenDisplay(NULL);
  w = XCreateSimpleWindow(d, RootWindow(d, 0), 100, 100, 
          WIN_WIDTH, WIN_HEIGHT, 2, BlackPixel(d, 0), WhitePixel(d, 0));
  g = XCreateGC(d, w, 0, 0);

  /*  륤٥Ȥ  */
  /*  ޥܥ󡢥ɥϪݥ󥿰ư  */
  XSelectInput(d, w, ExposureMask | ButtonPressMask | PointerMotionMask);
  XMapWindow(d, w);
  XStoreName(d, w, argv[0]);

  /*  Ƽ磻٥Ȥбᥤ󡦥롼  */
  for (;;) {
    XNextEvent(d, &e);
    /*  ޥܥ󤬲줿齪λ  */
    if (e.type == ButtonPress) break;
    /*  ɥϪ顢  */
    if (e.type == Expose) draw(d, w, g);
    /*  ݥ󥿤ư顢ΰ֤˱Ʒ׻ɽ  */
    if (e.type == MotionNotify) {
      kx = (double)e.xmotion.x * range / WIN_WIDTH;
      ky = (double)e.xmotion.y * range / WIN_HEIGHT;
      make_points(kx, ky);
      draw(d, w, g);
    }
  }

  /*  إץνλ  */
  XCloseDisplay(d);
}
