/* 
 * title : shownet1.c  -  draw net
 * begin : 2002/01/14
 * make  : gcc shownet1.c -o shownet1 -lm -I/usr/X11R6/include -L/usr/X11R6/lib -lX11
 * 
 */

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <math.h>
#include <stdio.h>

#define  MAX_POS     50
#define  WIN_WIDTH   320
#define  WIN_HEIGHT  320

int redraw(Display *d, Window w, GC gc, XPoint *top, int n)
{
  int i, j;
  /* Ū˷ */
  for (i = 0; i < n; i++) 
    for (j = 0; j < n; j++) 
      if (i != j) XDrawLine(d, w, gc, top[i].x ,top[i].y, top[j].x, top[j].y);
}


main(int argc, char **argv)
{
  Display *d;
  Window w;
  int black, white;
  GC gc;
  XEvent e;
  int i, n;
  double dt, th;
  XPoint top[MAX_POS+1];

  if (argc <= 1) {
    fprintf(stderr, "usage : %s <number of tops>\n", argv[0]);
    exit(1);
  }

  sscanf(argv[1], "%d", &n);
  if (n >= MAX_POS) {
    fprintf(stderr, "sorry, parameter must be less than %d.\n", MAX_POS);
    exit(1);
  }

  /* ޤȤĺɸ׻ */
  dt = (2*M_PI) / n;
  for (i = 0; i <= n; i++) {
    th += dt;
    top[i].x = WIN_WIDTH/2  + (WIN_WIDTH/2-10) * cos(th);
    top[i].y = WIN_HEIGHT/2 - (WIN_HEIGHT/2-10) * sin(th);
  }

  d = XOpenDisplay(NULL);
  w = XCreateSimpleWindow(d, RootWindow(d, 0), 100, 100, WIN_WIDTH, WIN_HEIGHT, 2, BlackPixel(d, 0), WhitePixel(d, 0));

  gc = XCreateGC(d, w, 0, 0);
  XSelectInput(d, w, ExposureMask | ButtonPressMask);
  XMapWindow(d, w);

  while (1){
    XNextEvent(d, &e);
    if (e.type == Expose)
      redraw(d, w, gc, top, n+1);
    if (e.type == ButtonPress)
      break;
  }
  XCloseDisplay(d);

}
