/* 
 * title : showpol1.c  -  draw polygon
 * begin : 2002/01/14
 * make  : gcc showpol1.c -o showpol1 -lm -I/usr/X11R6/include -L/usr/X11R6/lib -lX11
 * 
 */

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <math.h>
#include <stdio.h>

/* ĺοξ */
#define  MAX_POS     50
/* ɥ */
#define  WIN_WIDTH   320
#define  WIN_HEIGHT  320

int redraw(Display *d, Window w, GC gc, int n)
{
  int i;
  double th = 0, dt, x, y, xn, yn;

  XClearWindow(d, w);
  dt = (2*M_PI) / n;
  x = WIN_WIDTH/2  + (WIN_WIDTH/2-10) * cos(th);
  y = WIN_HEIGHT/2 - (WIN_HEIGHT/2-10) * sin(th);
  for (i = 1; i <= n; i++) {
    th += dt;
    xn = WIN_WIDTH/2  + (WIN_WIDTH/2-10) * cos(th);
    yn = WIN_HEIGHT/2 - (WIN_HEIGHT/2-10) * sin(th);
    XDrawLine(d, w, gc, x, y, xn, yn);
    x = xn;  y = yn;
  }
}


main(int argc, char **argv)
{
  Display *d;
  Window w;
  GC gc;
  XEvent e;
  int n;

  if (argc <= 1) {
    fprintf(stderr, "usage : %s <number of tops>\n", argv[0]);
    exit(1);
  }

  sscanf(argv[1], "%d", &n);
  if (n >= MAX_POS) {
    fprintf(stderr, "sorry, parameter must be less than %d.\n", MAX_POS);
    exit(1);
  }

  d = XOpenDisplay(NULL);
  w = XCreateSimpleWindow(d, RootWindow(d, 0), 100, 100, WIN_WIDTH, WIN_HEIGHT, 2, BlackPixel(d, 0), WhitePixel(d, 0));
  gc = XCreateGC(d, w, 0, 0);
  XSelectInput(d, w, ExposureMask | ButtonPressMask);
  XMapWindow(d, w);

  while (1){
    XNextEvent(d, &e);
    if (e.type == Expose)
      redraw(d, w, gc, n);
    if (e.type == ButtonPress)
      break;
  }

  XCloseDisplay(d);
}
