/* 
 * title : xbounce.c
 * begin : 2001/10/29
 * note  : 
 * make  : gcc xbounce.c -o xbounce -lm -I/usr/X11R6/include -L/usr/X11R6/lib -lX11 
 * 
 */

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <stdio.h>
#include <math.h>

/* ɥ礭 */
#define  WIN_WIDTH  600
#define  WIN_HEIGHT 500

/* ʪ֤礭 */
#define  REAL_WIDTH   1.2
#define  REAL_HEIGHT  1

/* ܡ礭 */
#define  B_RADIUS   30

/* ʪ */
#define  E          0.8    /*  (̤ΤߤŬ) */
#define  V          2.0    /* ® */
#define  A          0.0    /* ͳ (in degree) */
#define  G          9.8    /* ͳ® */
#define  Y0         0.9    /* ͹ */
#define  DT         0.01   /* ʬζ (units = second) */

/* ܡ빽¤ */
struct Ball {
  double x;
  double y;
  double vx;
  double vy;
};

/* 饸ؤѴ */
double toRad(double deg)
{
  return (deg / 180 * M_PI);
}

/* ܡؿ */
int draw_ball(Display *d, Window w, GC gc, double x, double y)
{
  int i, j;

  i = x / REAL_WIDTH * WIN_WIDTH;
  j = (REAL_HEIGHT - y) / REAL_HEIGHT * WIN_HEIGHT;

  /* ɤ */
  XSetForeground(d, gc, BlackPixel(d, 0));
  XFillArc(d, w, gc, i, j, B_RADIUS, B_RADIUS,
           0, 360*64);
  /* ȴ */
  XSetForeground(d, gc, WhitePixel(d, 0));
  XDrawArc(d, w, gc, i, j, B_RADIUS, B_RADIUS,
           0, 360*64);
  XFlush(d);
}


int main(int argc, char *argv[])
{
  Display *d;
  Window r, w;
  GC gc;
  XEvent evnt;
  struct Ball ball;
  double e = E, v = V, a = A, g = G, dt = DT;
  int idx;

  /* ޥɥ饤󤫤ѥ᥿ */
  idx = 1;
  while (idx < argc) {
    /* إɽ */
    if (strcmp(argv[idx], "-h") == 0) {
      fprintf(stderr, "*** %s\n", argv[0]);
      fprintf(stderr, "options as follows:\n");
      fprintf(stderr, "  [-h]\n");
      fprintf(stderr, "  [-e  <erastic coefficient for floor and wall>]\n");
      fprintf(stderr, "  [-v  <initial throw velocity>]\n");
      fprintf(stderr, "  [-a  <throw angle in degree : holizontal=0>]\n");
      fprintf(stderr, "  [-g  <gravitic constant>]\n");
      fprintf(stderr, "see document for more informations.\n");
      exit(1);
    } else
    /*  */
    if (strcmp(argv[idx], "-e") == 0)
      sscanf(argv[++idx], "%lf", &e);
    else
    /* ͽ® */
    if (strcmp(argv[idx], "-v") == 0)
      sscanf(argv[++idx], "%lf", &v);
    else
    /* ͳ */
    if (strcmp(argv[idx], "-a") == 0)
      sscanf(argv[++idx], "%lf", &a);
    else
    /* Ϸ */
    if (strcmp(argv[idx], "-g") == 0)
      sscanf(argv[++idx], "%lf", &g);
    else {
      fprintf(stderr, "Unknown option : %s\n", argv[idx]);
      exit(1);
    }
    idx++;
  }

  printf("erastic coefficient : %g\n", e);
  printf("velocity            : %g\n", v);
  printf("throw angle         : %g\n", a);
  printf("gravity             : %g\n", g);

  ball.x = 0;    ball.y = Y0;
  ball.vx = v * cos(toRad(a));   ball.vy = v * sin(toRad(a));

  d = XOpenDisplay(NULL);
  r = RootWindow(d, 0);
  /* ܡ礭ʬޡäƤ */
  w = XCreateSimpleWindow(d, r,  25,  25,
         WIN_WIDTH + B_RADIUS, WIN_HEIGHT + B_RADIUS, 2, BlackPixel(d, 0), WhitePixel(d, 0));
  gc = XCreateGC(d, w, 0, 0);
  XSelectInput(d, w, ExposureMask | ButtonPressMask);
  XMapWindow(d, w);

  /* ɥޥåפޤԤ */
  while (1) {
    XNextEvent(d, &evnt);
    if (evnt.type == Expose) break;
  }

  while (1) {
    /* ޥܥ󤬲줿顢롼פæƽλ */
    XCheckMaskEvent(d, ButtonPress, &evnt);
    if (evnt.type == ButtonPress) break;
    /* ܡ */
    draw_ball(d, w, gc, ball.x , ball.y);
    /* ʬˤ֡®٤ι³ */
    /* 褺ϣΰ֤򹹿 */
    ball.x += ball.vx * dt;
    /* ü˹Ԥä顢ȿͽ */
    if (ball.x < 0) {
      ball.x = 0;
      ball.vx = -e * ball.vx;
    } else
    /* ü˹Ԥä顢ȿͽ */
    if (ball.x >= REAL_WIDTH) {
      ball.x = REAL_WIDTH;
      ball.vx = -e * ball.vx;
    }
    /* ³ƣι */
    ball.y += ball.vy * dt;
    /* ã顢ȿͽ */
    if (ball.y < 0) {
      ball.y = 0;
      ball.vy = -e * ball.vy;
    }
    /* ϲ®٤ˤ®٤ι */
    ball.vx += 0;
    ball.vy += -g * dt;
    /* ٻ */
    usleep(10000);
  }
  /*  */
  XCloseDisplay(d);
}
