/* 
 * title : xbutton1.c  -  ֥ܥ󡦥ƥȡ
 * begin : 2002/04/16
 * make  : gcc xbutton1.c -o xbutton1 -I/usr/X11R6/include -L/usr/X11R6/lib -lX11
 * 
 */

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <stdio.h>

/* եȻ */
#define ALPHA_FONT "-*-helvetica-medium-r-normal--16-*-*-*-*-*-*-*"
#define KANJI_FONT "-jis-fixed-medium-r-normal--24-*-*-*-*-*-jisx0208.1983-0"
/* ɥ礭 */
#define WIN_WIDTH  150
#define WIN_HEIGHT 70
/* ܥ礭 */
#define BTN_WIDTH  105
#define BTN_HEIGHT 30
/* ʸĹ */
#define STR_LEN  128

/* ܥʸ */
#define  NORMAL_FACE  "ð"
#define  FOCUS_FACE   ""
#define  PUSHED_FACE  "䡼"

/* functions */

/* ʸؿ */
/* ХǵꣲХȤʸʸƬФ */
int getLtr(char *str)
{
  int c, d;
  c = *str;
  d = *(++str);
  if (c >= 0 && c <= 0x7f) return c;
  return c * 256 + d;
}

/* ʸؿ */
/* եȹ¤ΤȤΤϡȤΤȤޤ */
int drawStr(Display *d, Window w, GC gc_eng, GC gc_knj, XFontStruct *f_e, XFontStruct *f_k, int x, int y, char *p)
{
  int     c;
  char    eng[2];
  XChar2b knj[2];

  while (*p != '\0') {
    c = getLtr(p);
    if (c >= 0 && c <= 0x7f) {
    /* Хʸξ */
      eng[0] = c;
      XDrawString(d, w, gc_eng, x, y, eng, 1);
      x += XTextWidth(f_e, eng, 1);
      p++;
    }
    else {
    /* Хʸξ */
      knj[0].byte1 = (c / 256) & 0x7f;
      knj[0].byte2 = (c % 256) & 0x7f;
      XDrawString16(d, w, gc_knj, x, y, knj, 2);
      x += XTextWidth16(f_k, knj, 1);
      p+=2;
    }
  }
}

/* ꤹ */
unsigned long get_color(Display *d, char *color) 
{
  Colormap cmap;
  XColor c0, c1;
  
  cmap = DefaultColormap(d, 0);
  XAllocNamedColor(d, cmap, color, &c1, &c0);
  /* ꤷ˶ᤤȤ */
    return c1.pixel;
}


main(int argc, char *argv[])
{
  Display  *disp;
  Window  win, btn;
  XFontStruct  *f_a, *f_k;
  GC  gc_a, gc_k;
  XEvent  evnt;
  XSetWindowAttributes  att;
  XSizeHints sizehint;
  char  fg[STR_LEN], bg[STR_LEN];
  unsigned int  col_fg, col_bg;
  char *btn_name = NORMAL_FACE;
  int  idx = 1;

  strcpy(fg,  "Black");
  strcpy(bg,  "light gray");

  /* ޥɥ饤󤫤ѥ᥿ */
  while (idx < argc) {
    /* إɽ */
    if (strcmp(argv[idx], "-h") == 0) {
      fprintf(stderr, "*** An attractive button.\n");
      fprintf(stderr, "Usage : %s [-fg <col>] [-bg <col>]\n", argv[0]);
      fprintf(stderr, "options as follows:\n");
      fprintf(stderr, "  [-h]\n");
      fprintf(stderr, "  [-fg <foreground color>]\n");
      fprintf(stderr, "  [-bg <background color>]\n");
      fprintf(stderr, "see document for more informations, thanks.\n");
      exit(1);
    } else
    /* ʿ */
    if (strcmp(argv[idx], "-fg") == 0)
      sscanf(argv[++idx], "%s", fg);
    else
    /* طʿ */
    if (strcmp(argv[idx], "-bg") == 0)
      sscanf(argv[++idx], "%s", bg);

    idx++;
  }

  /* 饦ɥλϤޤ */
  disp = XOpenDisplay(NULL);
  /* ɥطʿ */
  col_fg = get_color(disp, fg);
  col_bg = get_color(disp, bg);
  /* ɥߤ */
  win = XCreateSimpleWindow(disp, RootWindow(disp, 0),
          10, 900, WIN_WIDTH, WIN_HEIGHT, 2, col_fg, col_bg);
  btn = XCreateSimpleWindow(disp, win,
          20, 30,  BTN_WIDTH, BTN_HEIGHT, 2, col_fg, col_bg);
  /*  */
  XSelectInput(disp, win, ExposureMask | StructureNotifyMask | KeyPressMask);
  XSelectInput(disp, btn, ExposureMask | ButtonPressMask | StructureNotifyMask | EnterWindowMask | LeaveWindowMask);
  /* եȤɤ߹ǡꤹ */
  /* ʪ碌ʤΤǡեȤѤˤϳƼѥ᥿Ѥɬפ */
  gc_a = XCreateGC(disp, RootWindow(disp, 0), 0, 0);
  gc_k = XCreateGC(disp, RootWindow(disp, 0), 0, 0);
  f_a = XLoadQueryFont(disp, ALPHA_FONT);
  f_k = XLoadQueryFont(disp, KANJI_FONT);
  XSetFont(disp, gc_a, f_a->fid);
  XSetFont(disp, gc_k, f_k->fid);
  /* ʸ˿դ١ǣäʿꤹ */
  XSetForeground(disp, gc_a, col_fg);
  XSetForeground(disp, gc_k, col_fg);
  /* ɥޥ͡㡼˥ȥΤ */
  XStoreName(disp, win, "xbutton1");
  /* ɥޥ͡㡼ˤ륦ɥ礭ѹ޻ߤ */
  sizehint.flags = USSize | PMinSize | PMaxSize;
  sizehint.min_width  = WIN_WIDTH;
  sizehint.min_height = WIN_HEIGHT;
  sizehint.max_width  = WIN_WIDTH;
  sizehint.max_height = WIN_HEIGHT;
  XSetWMNormalHints(disp, win, &sizehint);
  /* ɥɽ */
  XMapWindow(disp, win);
  XMapWindow(disp, btn);

  while (1) {
    XNextEvent(disp, &evnt);
    /* ǽλ */
    if (evnt.type == KeyPress) 
      break;
    /* ޥܥ󲡲ǥܥʸѹ */
    if (evnt.type == ButtonPress) {
      btn_name = PUSHED_FACE;
      XClearWindow(disp, btn);
      drawStr(disp, btn, gc_a, gc_k, f_a, f_k, 3, 25, (char *)btn_name);
    }
    /* ɥϪФ顢 */
    if (evnt.type == Expose && evnt.xany.window == win) {
      drawStr(disp, win, gc_a, gc_k, f_a, f_k, 5, 18, "An attractive button");
      drawStr(disp, btn, gc_a, gc_k, f_a, f_k, 3, 25, (char *)btn_name);
    }
    /* ݥ󥿤äܥʸѹ */
    if (evnt.type == EnterNotify && evnt.xcrossing.window == btn) {
      btn_name = FOCUS_FACE;
      XClearWindow(disp, btn);
      drawStr(disp, btn, gc_a, gc_k, f_a, f_k, 3, 25, (char *)btn_name);
    }
    /* ݥ󥿤Ф顢ܥʸ᤹ */
    if (evnt.type == LeaveNotify && evnt.xcrossing.window == btn) {
      btn_name = NORMAL_FACE;
      XClearWindow(disp, btn);
      drawStr(disp, btn, gc_a, gc_k, f_a, f_k, 3, 25, (char *)btn_name);
    }
  }
  XCloseDisplay(disp);

}
