/* 
 * title : xbutton2.c  -  ֥ܥ󡦥ƥȡ
 * begin : 2002/04/16
 * make  : gcc xbutton2.c -o xbutton2 -I/usr/X11R6/include -L/usr/X11R6/lib -lX11
 * 
 */

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <stdio.h>

/* ܥɽ */
#include  "face.bmp"

/* եȻ */
#define ALPHA_FONT "-*-helvetica-medium-r-normal--16-*-*-*-*-*-*-*"
#define KANJI_FONT "-jis-fixed-medium-r-normal--16-*-*-*-*-*-jisx0208.1983-0"
/* ɥ礭 */
#define WIN_WIDTH  150
#define WIN_HEIGHT 200
#define BLN_WIDTH  100
#define BLN_HEIGHT 20
/* ʸĹ */
#define STR_LEN  128

/* ᤭Фʸ */
#define  BALOON_0      "եե"
#define  BALOON_1      ""

/* functions */

/* ʸؿ */
/* ХǵꣲХȤʸʸƬФ */
int getLtr(char *str)
{
  int c, d;
  c = *str;
  d = *(++str);
  if (c >= 0 && c <= 0x7f) return c;
  return c * 256 + d;
}

/* ʸؿ */
/* եȹ¤ΤȤΤϡȤΤȤޤ */
int drawStr(Display *d, Window w, GC gc_eng, GC gc_knj, XFontStruct *f_e, XFontStruct *f_k, int x, int y, char *p)
{
  int     c;
  char    eng[2];
  XChar2b knj[2];

  while (*p != '\0') {
    c = getLtr(p);
    if (c >= 0 && c <= 0x7f) {
    /* Хʸξ */
      eng[0] = c;
      XDrawString(d, w, gc_eng, x, y, eng, 1);
      x += XTextWidth(f_e, eng, 1);
      p++;
    }
    else {
    /* Хʸξ */
      knj[0].byte1 = (c / 256) & 0x7f;
      knj[0].byte2 = (c % 256) & 0x7f;
      XDrawString16(d, w, gc_knj, x, y, knj, 2);
      x += XTextWidth16(f_k, knj, 1);
      p+=2;
    }
  }
}

/* ꤹ */
unsigned long get_color(Display *d, char *color) 
{
  Colormap cmap;
  XColor c0, c1;
  
  cmap = DefaultColormap(d, 0);
  XAllocNamedColor(d, cmap, color, &c1, &c0);
  /* ꤷ˶ᤤȤ */
    return c1.pixel;
}


int main(int argc, char *argv[])
{
  Display  *disp;
  Window  win, btn, baloon;
  Pixmap  pix[2];
  XFontStruct  *f_a, *f_k;
  GC  gc_a, gc_k;
  XEvent  evnt;
  XSetWindowAttributes  attr;
  XSizeHints  sizehint;
  char  fg[STR_LEN], bg[STR_LEN];
  char  msg[2][STR_LEN];
  unsigned int  col_fg, col_bg;
  int btn_name = 0;
  int btn_state = 0;
  int  idx = 1;

  strcpy(fg,  "Black");
  strcpy(bg,  "light gray");
  strcpy(msg[0], BALOON_0);
  strcpy(msg[1], BALOON_1);

  /* ޥɥ饤󤫤ѥ᥿ */
  while (idx < argc) {
    /* إɽ */
    if (strcmp(argv[idx], "-h") == 0) {
      fprintf(stderr, "*** An attractive button.\n");
      fprintf(stderr, "Usage : %s [-fg <col>] [-bg <col>]\n", argv[0]);
      fprintf(stderr, "options as follows:\n");
      fprintf(stderr, "  [-h]\n");
      fprintf(stderr, "  [-fg <foreground color>]\n");
      fprintf(stderr, "  [-bg <background color>]\n");
      fprintf(stderr, "see document for more informations, thanks.\n");
      exit(1);
    } else
    /* ʿ */
    if (strcmp(argv[idx], "-fg") == 0)
      sscanf(argv[++idx], "%s", fg);
    else
    /* طʿ */
    if (strcmp(argv[idx], "-bg") == 0)
      sscanf(argv[++idx], "%s", bg);

    idx++;
  }

  /* 饦ɥλϤޤ */
  disp = XOpenDisplay(NULL);
  /* ɥطʿ */
  col_fg = get_color(disp, fg);
  col_bg = get_color(disp, bg);
  /* ɥߤ */
  win = XCreateSimpleWindow(disp, RootWindow(disp, 0),
          10, 900, WIN_WIDTH, WIN_HEIGHT, 2, col_fg, col_bg);
  btn = XCreateSimpleWindow(disp, win,
          20, 30,  face_width, face_height, 2, col_fg, col_bg);
  baloon = XCreateSimpleWindow(disp, RootWindow(disp, 0),
          20, 30,  BLN_WIDTH, BLN_HEIGHT, 1, col_fg, col_bg);
  /* ܥβ */
  pix[0] = XCreatePixmapFromBitmapData(disp, btn, face_bits, face_width,
          face_height, col_fg, col_bg, DefaultDepth(disp, 0));
  pix[1] = XCreatePixmapFromBitmapData(disp, btn, face_bits, face_width,
          face_height, col_bg, col_fg, DefaultDepth(disp, 0));

  /*  */
  XSelectInput(disp, win, ExposureMask | StructureNotifyMask | KeyPressMask);
  XSelectInput(disp, btn, ExposureMask | ButtonPressMask | StructureNotifyMask | EnterWindowMask | LeaveWindowMask);
  /* եȤɤ߹ǡꤹ */
  /* ʪ碌ʤΤǡեȤѤˤϳƼѥ᥿Ѥɬפ */
  gc_a = XCreateGC(disp, RootWindow(disp, 0), 0, 0);
  gc_k = XCreateGC(disp, RootWindow(disp, 0), 0, 0);
  f_a = XLoadQueryFont(disp, ALPHA_FONT);
  f_k = XLoadQueryFont(disp, KANJI_FONT);
  XSetFont(disp, gc_a, f_a->fid);
  XSetFont(disp, gc_k, f_k->fid);
  /* ʸ˿դ١ǣäʿꤹ */
  XSetForeground(disp, gc_a, col_fg);
  XSetForeground(disp, gc_k, col_fg);
  /* ɥޥ͡㡼˥ȥΤ */
  XStoreName(disp, win, "xbutton2");
  /* ɥޥ͡㡼ˤ륦ɥ礭ѹ޻ߤ */
  sizehint.flags = USSize | PMinSize | PMaxSize;
  sizehint.min_width  = WIN_WIDTH;
  sizehint.min_height = WIN_HEIGHT;
  sizehint.max_width  = WIN_WIDTH;
  sizehint.max_height = WIN_HEIGHT;
  XSetWMNormalHints(disp, win, &sizehint);
  /* Х롼󥦥ɥФ롢ɥޥ͡㡼β˻ */
  attr.override_redirect = True;
  XChangeWindowAttributes(disp, baloon, CWOverrideRedirect, &attr);
  /* ܥ󥦥ɥΥХåɤ˲Žդ */
  XSetWindowBackgroundPixmap(disp, btn, pix[btn_state]);
  /* ɥɽ */
  XMapWindow(disp, win);
  XMapWindow(disp, btn);

  while (1) {
    XNextEvent(disp, &evnt);
    /* ǽλ */
    if (evnt.type == KeyPress) 
      break;
    /* ޥܥ󲡲ǡܥξ֤򹹿 */
    if (evnt.type == ButtonPress) {
      btn_state = 1 - btn_state;
      XSetWindowBackgroundPixmap(disp, btn, pix[btn_state]);
      XClearWindow(disp, btn);
      XClearWindow(disp, baloon);
      drawStr(disp, baloon, gc_a, gc_k, f_a, f_k, 1, 16, (char *)msg[btn_state]);
    }
    /* ɥϪФ顢 */
    if (evnt.type == Expose && evnt.xany.window == win) {
      XClearWindow(disp, btn);
      drawStr(disp, win, gc_a, gc_k, f_a, f_k, 6, 18, "A riddleman button");
    }
    /* ݥ󥿤äХ롼ɽ */
    if (evnt.type == EnterNotify && evnt.xcrossing.window == btn) {
      XMapRaised(disp, baloon);
      XMoveWindow(disp, baloon, evnt.xcrossing.x_root+8, evnt.xcrossing.y_root+1);
      drawStr(disp, baloon, gc_a, gc_k, f_a, f_k, 1, 16, (char *)msg[btn_state]);
    }
    /* ݥ󥿤Ф顢Х롼ä */
    if (evnt.type == LeaveNotify && evnt.xcrossing.window == btn) {
      XUnmapWindow(disp, baloon);
    }
  }
  XCloseDisplay(disp);

}
