/* 
 * title : xhusen.c  -  䵻
 * begin : 2001/12/22
 * make  : gcc xhusen.c -o xhusen -I/usr/X11R6/include -L/usr/X11R6/lib -lX11
 * 
 */

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <stdio.h>

/* եȻŬѹƲ */
#define ALPHA_FONT "-*-helvetica-medium-r-normal--16-*-*-*-*-*-*-*"
#define KANJI_FONT "-jis-fixed-medium-r-normal--16-*-*-*-*-*-jisx0208.1983-0"
/* ɥ礭ʤŬѹƲ */
#define WIN_WIDTH  325  /* ΡʸǣʸٽФޤ */
#define WIN_HEIGHT 20
/* ʸĹ */
#define STR_LEN  128

/* functions */

/* ʸؿ */
/* ХǵꣲХȤʸʸƬФ */
int getLtr(char *str)
{
  int c, d;
  c = *str;
  d = *(++str);
  if (c >= 0 && c <= 0x7f) return c;
  return c * 256 + d;
}

/* ʸؿ */
/* եȹ¤ΤȤΤϡȤΤȤޤ */
int drawStr(Display *d, Window w, GC gc_eng, GC gc_knj, XFontStruct *f_e, XFontStruct *f_k, int x, int y, char *p)
{
  int     c;
  char    eng[2];
  XChar2b knj[2];

  while (*p != '\0') {
    c = getLtr(p);
    if (c >= 0 && c <= 0x7f) {
    /* Хʸξ */
      eng[0] = c;
      XDrawString(d, w, gc_eng, x, y, eng, 1);
      x += XTextWidth(f_e, eng, 1);
      p++;
    }
    else {
    /* Хʸξ */
      knj[0].byte1 = (c / 256) & 0x7f;
      knj[0].byte2 = (c % 256) & 0x7f;
      XDrawString16(d, w, gc_knj, x, y, knj, 2);
      x += XTextWidth16(f_k, knj, 1);
      p+=2;
    }
  }
}

/* ꤹ */
unsigned long get_color(Display *d, char *color) 
{
  Colormap cmap;
  XColor c0, c1;
  
  cmap = DefaultColormap(d, 0);
  XAllocNamedColor(d, cmap, color, &c1, &c0);
  /* ꤷ˶ᤤȤ */
    return c1.pixel;
}


main(int argc, char *argv[])
{
  Display  *disp;
  Window  win;
  XFontStruct  *f_a, *f_k;
  GC  gc_a, gc_k;
  XEvent  evnt;
  XSetWindowAttributes  att;
  char  msg[STR_LEN];
  char  fg[STR_LEN], bg[STR_LEN];
  unsigned int  col_fg, col_bg;
  int  idx = 1;

  strcpy(msg, "䵻 ver 1.0");
  strcpy(fg,  "Black");
  strcpy(bg,  "White");

  /* ޥɥ饤󤫤ѥ᥿ */
  while (idx < argc) {
    /* إɽ */
    if (strcmp(argv[idx], "-h") == 0) {
      fprintf(stderr, "*** Tiny husenshi for X.\n");
      fprintf(stderr, "Usage : %s [-fg <col>] [-bg <col>] <message in EUC>\n", argv[0]);
      fprintf(stderr, "options as follows:\n");
      fprintf(stderr, "  [-h]\n");
      fprintf(stderr, "  [-fg <foreground color>]\n");
      fprintf(stderr, "  [-bg <background color>]\n");
      fprintf(stderr, "see document for more informations, thanks.\n");
      exit(1);
    } else
    /* ʿ */
    if (strcmp(argv[idx], "-fg") == 0)
      sscanf(argv[++idx], "%s", fg);
    else
    /* طʿ */
    if (strcmp(argv[idx], "-bg") == 0)
      sscanf(argv[++idx], "%s", bg);
    /* å */
    else
      strcpy(msg, argv[idx]);
    idx++;
  }

  /* 饦ɥλϤޤ */
  disp = XOpenDisplay(NULL);
  /* ɥطʿ */
  col_fg = get_color(disp, fg);
  col_bg = get_color(disp, bg);
  /* ɥߤ */
  win = XCreateSimpleWindow(disp, RootWindow(disp, 0),
          10, 900, WIN_WIDTH, WIN_HEIGHT, 2, col_fg, col_bg);
  /* ꡧܥ˽Ϫɥ礭ѹ */
  XSelectInput(disp, win, ExposureMask | ButtonPressMask | StructureNotifyMask);
  /* եȤɤ߹ǡꤹ */
  /* ʪ碌ʤΤǡեȤѤˤϳƼѥ᥿Ѥɬפ */
  gc_a = XCreateGC(disp, RootWindow(disp, 0), 0, 0);
  gc_k = XCreateGC(disp, RootWindow(disp, 0), 0, 0);
  f_a = XLoadQueryFont(disp, ALPHA_FONT);
  f_k = XLoadQueryFont(disp, KANJI_FONT);
  XSetFont(disp, gc_a, f_a->fid);
  XSetFont(disp, gc_k, f_k->fid);
  /* ʸ˿դ١ǣäʿꤹ */
  XSetForeground(disp, gc_a, col_fg);
  XSetForeground(disp, gc_k, col_fg);
  /* ɥޥ͡㡼˥ȥΤ */
  XStoreName(disp, win, "xhusen");
  /* 롼ȤΣɥˤơǥ졼򲡤 */
  /* ʣǤϸ̵ */
  XSetTransientForHint(disp, win, RootWindow(disp, 0));
  /* ɥɽ */
  XMapWindow(disp, win);

  while (1) {
    XNextEvent(disp, &evnt);
    /* ޥܥ󲡲ǽλ */
    if (evnt.type == ButtonPress) 
      break;
    /* ɥ礭ѹǤ⡢᤹ */
    if (evnt.type == ConfigureNotify) 
      XResizeWindow(disp, win, WIN_WIDTH, WIN_HEIGHT);
    /* ɥϪФ顢 */
    if (evnt.type == Expose && evnt.xany.window == win) {
      drawStr(disp, win, gc_a, gc_k, f_a, f_k, 3, 16, (char *)msg);
    }

  }
  XCloseDisplay(disp);

}
