/* 
 * title : xhusen_server.c  -  䵻極
 * begin : 2002/03/21
 * note  : 饤ȡŪʥ̿
 * make  : gcc xhusen_s.c -o xhusen_s -I/usr/X11R6/include -L/usr/X11R6/lib -lX11
 * 
 */

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xatom.h>
#include <stdio.h>
#include <string.h>

/* եȻŬѹƲ */
#define ALPHA_FONT "-*-helvetica-medium-r-normal--16-*-*-*-*-*-*-*"
#define KANJI_FONT "-jis-fixed-medium-r-normal--16-*-*-*-*-*-jisx0208.1983-0"
/* ɥ礭ʤŬѹƲ */
#define WIN_WIDTH  325
#define WIN_HEIGHT 20
/* ʸĹ */
#define STR_LEN  128
/* Ȥ䵤ξ */
#define HUSEN_LIMIT 30
/* ̿˻Ȥȥ̾ */
#define ATOM_NAME  "X-HUSEN-SHI"
#define ATOM_CMD   "MESSAGE"

/* 䵻湽¤ */
struct Husen {
  Window  win;            /* 䵻楦ɥ */
  char    msg[STR_LEN];   /* 䵻 */
  int     flg;            /* ĥդƤ뤫ɤΥե饰 */
} husen[HUSEN_LIMIT];


/* functions */

/* ʸؿ */
/* ХǵꣲХȤʸʸƬФ */
int getLtr(char *str)
{
  int c, d;
  c = *str;
  d = *(++str);
  if (c >= 0 && c <= 0x7f) return c;
  return c * 256 + d;
}

/* ʸؿ */
/* եȹ¤ΤȤΤϡȤΤȤޤ */
int drawStr(Display *d, Window w, GC gc_eng, GC gc_knj, XFontStruct *f_e, XFontStruct *f_k, char *p)
{
  int     c;
  int     x = 3, y = 16;
  char    eng[2];
  XChar2b knj[2];

  while (*p != '\0') {
    c = getLtr(p);
    if (c >= 0 && c <= 0x7f) {
    /* Хʸξ */
      eng[0] = c;
      XDrawString(d, w, gc_eng, x, y, eng, 1);
      x += XTextWidth(f_e, eng, 1);
      p++;
    }
    else {
    /* Хʸξ */
      knj[0].byte1 = (c / 256) & 0x7f;
      knj[0].byte2 = (c % 256) & 0x7f;
      XDrawString16(d, w, gc_knj, x, y, knj, 2);
      x += XTextWidth16(f_k, knj, 1);
      p+=2;
    }
  }
}

/* ꤹ */
unsigned long get_color(Display *d, char *color) 
{
  Colormap cmap;
  XColor c0, c1;
  
  cmap = DefaultColormap(d, 0);
  XAllocNamedColor(d, cmap, color, &c1, &c0);
  /* ꤷ˶ᤤȤ */
    return c1.pixel;
}


int main(int argc, char *argv[])
{
  Display  *disp;
  Window   w;
  XFontStruct  *f_a, *f_k;
  GC  gc_a, gc_k;

  Atom  a1, a2;
  XEvent  evnt;
  XSetWindowAttributes  att;
  char  fg[STR_LEN], bg[STR_LEN];
  unsigned int  col_fg, col_bg;
  int  idx = 1;
  int  i;
  unsigned char letter[2] = { 0x00, 0x00 };
  int  flg_reading = False;

  /* ǥեȤο */
  strcpy(fg,  "Black");
  strcpy(bg,  "White");

  /* ޥɥ饤󤫤ѥ᥿ */
  while (idx < argc) {
    /* إɽ */
    if (strcmp(argv[idx], "-h") == 0) {
      fprintf(stderr, "*** Tiny husenshi server for X.\n");
      fprintf(stderr, "Usage : %s [-fg <col>] [-bg <col>]\n", argv[0]);
      fprintf(stderr, "options as follows:\n");
      fprintf(stderr, "  [-h]\n");
      fprintf(stderr, "  [-fg <foreground color name>]\n");
      fprintf(stderr, "  [-bg <background color name>]\n");
      fprintf(stderr, "limits of %d husen-shi in current.\n", HUSEN_LIMIT);
      fprintf(stderr, "see document for more informations, thanks.\n");
      exit(1);
    } else
    /* ʿ */
    if (strcmp(argv[idx], "-fg") == 0)
      sscanf(argv[++idx], "%s", fg);
    else
    /* طʿ */
    if (strcmp(argv[idx], "-bg") == 0)
      sscanf(argv[++idx], "%s", bg);
    else {
      fprintf(stderr, "unknown option : %s\n", argv[idx]);
      exit(1);
    }
    idx++;
  }

  disp = XOpenDisplay(NULL);
  /* ɥطʿ */
  col_fg = get_color(disp, fg);
  col_bg = get_color(disp, bg);
  for (i = 0; i < HUSEN_LIMIT; i++) {
    /* ɥߤ */
    husen[i].win = XCreateSimpleWindow(disp, RootWindow(disp, 0),
            10, 900, WIN_WIDTH, WIN_HEIGHT, 2, col_fg, col_bg);
    /* ꡧܥ˽Ϫɥ礭ѹ */
    XSelectInput(disp, husen[i].win, ExposureMask | ButtonPressMask | StructureNotifyMask);
    /* ĥդե饰򥯥ꥢƤ */
    husen[i].flg = 0;
  }

  w = XCreateSimpleWindow(disp, RootWindow(disp, 0),
          10, 900, WIN_WIDTH, WIN_HEIGHT, 2, col_fg, col_bg);

  /* եȤɤ߹ǡꤹ */
  /* ʪ碌ʤΤǡեȤѤˤϳƼѥ᥿Ѥɬפ */
  gc_a = XCreateGC(disp, RootWindow(disp, 0), 0, 0);
  gc_k = XCreateGC(disp, RootWindow(disp, 0), 0, 0);
  f_a = XLoadQueryFont(disp, ALPHA_FONT);
  f_k = XLoadQueryFont(disp, KANJI_FONT);
  XSetFont(disp, gc_a, f_a->fid);
  XSetFont(disp, gc_k, f_k->fid);
  /* ʸ˿դ١ǣäʿꤹ */
  XSetForeground(disp, gc_a, col_fg);
  XSetForeground(disp, gc_k, col_fg);

  /* ̿˻Ȥȥ */
  a1 = XInternAtom(disp, ATOM_NAME, False);
  XChangeProperty(disp, RootWindow(disp, 0), a1, XA_WINDOW, 32,
                  PropModeReplace, (unsigned char *)&w, 1);
  a2 = XInternAtom(disp, ATOM_CMD, False);


  while (1) {
    XNextEvent(disp, &evnt);
    /* 饤ȥå褿顢ν */
    if (evnt.type == ClientMessage && evnt.xclient.message_type == a2) {
      /* åɤ߹ʤ */
      if (flg_reading == False) {
        /* Ƥ䵻õ */
	for (idx = 0; idx < HUSEN_LIMIT; idx++) 
	  if (husen[idx].flg == 0) {
            flg_reading = True;
            break;
	  }
	fprintf(stderr, "index : %d\n", idx);
        /* 䵻ζ̵ */
        if (idx == HUSEN_LIMIT) {
           fprintf(stderr, "%s : upper limit of husen (%d). cannot stick new one.\n", argv[0], HUSEN_LIMIT);
	} else {
          husen[idx].msg[0] = (unsigned char)evnt.xclient.data.b[0];
          husen[idx].msg[1] = '\0';
        }
      } else {
        /* 饤Ȥ飱Хȼ */
        letter[0] = (unsigned char)evnt.xclient.data.b[0];
        /* ʸλʤ */
        if (letter[0] == '\0') {
          /* ɥޥ͡㡼˥ȥΤ */
          XStoreName(disp, husen[idx].win, "xhusen");
          /* ɥɽ */
          XMapWindow(disp, husen[idx].win);
          /* ɤ߹߽λ */
          flg_reading = False; 
          /* ĥդե饰 */
          husen[idx].flg = 1;
        } else {
          /* ɤ߹ʸåʸդ­ */
          strcat(husen[idx].msg, letter);
        }
      }
    }
    /* ޥܥ󲡲ǡ֤Ϥ */
    if (evnt.type == ButtonPress) {
      for (i = 0; i < HUSEN_LIMIT; i++) 
	if (evnt.xany.window == husen[i].win) {
          XUnmapWindow(disp, husen[i].win);
          husen[i].flg = 0;
        }
    }
    /* ɥ礭ѹǤ⡢᤹ */
    if (evnt.type == ConfigureNotify) 
      for (i = 0; i < HUSEN_LIMIT; i++)
	if (evnt.xany.window == husen[i].win)
          XResizeWindow(disp, husen[i].win, WIN_WIDTH, WIN_HEIGHT);
    /* ɥϪФ顢 */
    if (evnt.type == Expose) {
      for (i = 0; i < HUSEN_LIMIT; i++)
	if (evnt.xany.window == husen[i].win)
          drawStr(disp, husen[i].win, gc_a, gc_k, f_a, f_k, (char *)husen[i].msg);
    }

  }
  /* Not reached ... */
  XCloseDisplay(disp);

}
