/* 
 * title : xmissile.c
 * begin : 2001/10/31
 * note  : ȶư˽񤭴
 * make  : gcc xmissile.c -o xmissile -DAUTO -lm -I/usr/X11R6/include -L/usr/X11R6/lib  -lX11
 *
 */

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <stdio.h>
#include <math.h>

/* ɥ礭 */
#define  WIN_WIDTH  600
#define  WIN_HEIGHT 500

/* ߥ® */
#define  V_MAX  20

/* ߥ */
#define  THRESH_ANGLE  170

/* ؿ */
int sgn(double r)
{
  if (r == 0) return 0;
  else
  if (r > 0)  return 1;
  else 
  return -1;
}

/* ٤򣲦ФϰϤ˼ؿ */
double fmodpi2(double f)
{
  f += 2 * M_PI;
  return (f - (int)(f / (2*M_PI)) * (2 * M_PI));
}

/* 饸Ѵ */
double frad(double fdeg)
{
  return (fdeg * M_PI / 180);
}

/* ݥ󥿺ɸĴ٤ */
int pointerp(Display *d, Window w, int *x, int *y)
{
  Window root, child;
  int rx, ry;
  unsigned int mask;
  return XQueryPointer(d, w, &root, &child, &rx, &ry, x, y, &mask);
}

int main()
{
  Display *d;
  Window r, win;
  GC gc;
  XEvent e;
  unsigned long black, white;
  int contact = 0, count = 0, xt, yt;
  double dt, x, y, v, w, th, ph, dst;

  /* ֳִ */
  dt = 0.1;
  /* ߥɸ */
  x = 0;  y = WIN_HEIGHT;
  /* ߥư */
  th = frad(-45); 
  /* ߥž® */
  w =  frad(60);
  /* ߥư® */
  v = V_MAX;

  d = XOpenDisplay(NULL);
  win = XCreateSimpleWindow(d, RootWindow(d, 0), 25, 25,
         WIN_WIDTH, WIN_HEIGHT, 2, BlackPixel(d, 0), WhitePixel(d, 0));
  gc = XCreateGC(d, win, 0, 0);
  XSelectInput(d, win, ExposureMask | LeaveWindowMask);
  XMapWindow(d, win);

  while (1) {
    XNextEvent(d, &e);
    if (e.type == Expose) break;
  }
  /* ݥ󥿤򥦥ɥ˰ư */
  XWarpPointer(d, None, 0, 0, 0, 0, w, WIN_WIDTH/2, WIN_HEIGHT/2);

  /* main loop */
  while (contact == 0) {
    pointerp(d, win, &xt, &yt);
    XDrawPoint(d, win, gc, x, y);
    /* ݥ󥿤ɥγؽФ顢λ */
    XCheckMaskEvent(d, LeaveWindowMask, &e);
    if (e.type == LeaveNotify) 
      contact = 1;
    /* Υ */
    x += dt * v * cos(th);
    y += dt * v * sin(th);
    /* ž */
    /* 褺ߥ뤫鸫ɸŪѤΤɤˤΤĴ٤ */
    ph = fmodpi2(atan2f(((double)yt - y), ((double)xt - x)));
    ph = ph - th;
    /* ߥθɸŪѤٰʤ */
    if (fabsf(ph) < frad(THRESH_ANGLE))
      /* Ѥؤžʤ */
      ph = sgn(ph);
    else 
      /* Ǥʤб󤹤 */
      ph = 1;
    /* ºݤžʬ */
    th = fmodpi2(th + dt * w * ph);
    /* ߥɸŪεΥ */
    dst = sqrt(((double)xt-x)*((double)xt-x) + ((double)yt-y)*((double)yt-y));
#ifdef AUTO
    /* ߥ뤬ɸŪ˶դ顢®٤Ȥ */
    v = V_MAX;
    if (dst < V_MAX) v = dst;
#endif
    /* ߥɸŪεΥ꾮ʤä顢ַơ */
    if (dst <= 1) contact = 2;
    usleep(30000);
    count++;
  }
  /* λ */
  if (contact == 1)
      printf("missing target ...\n");
  else
    printf("contact ... \n");

  printf("count = %d\n", count);
  XCloseDisplay(d);
}
