/* 
 * title : xtokei.c  -  ֻס
 * begin : 2002/03/23
 * make  : gcc xtokei.c -o xtokei -lm -I/usr/X11R6/include -L/usr/X11R6/lib -lX11
 * 
 */

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <stdio.h>
#include <time.h>
#include <signal.h>
#include <math.h>

/* 󲽤ݤΥǥʣե */
/* ߤΤΤäơꤷƲ */
#include "clk_icn.xbm"

/* եȻŬѹƲ */
#define ALPHA_FONT  "-*-helvetica-medium-r-normal--16-*-*-*-*-*-*-*"
#define KANJI_FONT  "-jis-fixed-medium-r-normal--16-*-*-*-*-*-jisx0208.1983-0"
/* ɥ礭 */
#define WIN_WIDTH   100
#define WIN_HEIGHT  100
/* Х롼󡦥ɥ礭 */
#define BLN_WIDTH   160
#define BLN_HEIGHT  20
/* Х롼ɽʸΥǥե */
#define BALOON_MSG  "copyright(c) MoSIB"

Display  *disp;
Window  win, baloon;
GC  gc_a, gc_k;
/* 顼ॷʥȯֳ */
int  ti = 1;

/* functions */

/* ʸؿ */
/* ХǵꣲХȤʸʸƬФ */
int getLtr(char *str)
{
  int c, d;
  c = *str;
  d = *(++str);
  if (c >= 0 && c <= 0x7f) return c;
  return c * 256 + d;
}

/* ʸؿ */
/* եȹ¤ΤȤΤϡȤΤȤޤ */
int drawStr(Display *d, Window w, GC gc_eng, GC gc_knj, XFontStruct *f_e, XFontStruct *f_k, int x, int y, char *p)
{
  int     c;
  char    eng[2];
  XChar2b knj[2];

  while (*p != '\0') {
    c = getLtr(p);
    if (c >= 0 && c <= 0x7f) {
      eng[0] = c;
      XDrawString(d, w, gc_eng, x, y, eng, 1);
      x += XTextWidth(f_e, eng, 1);
      p++;
    }
    else {
      knj[0].byte1 = (c / 256) & 0x7f;
      knj[0].byte2 = (c % 256) & 0x7f;
      XDrawString16(d, w, gc_knj, x, y, knj, 2);
      x += XTextWidth16(f_k, knj, 1);
      p+=2;
    }
  }
}

/* ˤ */
draw_hand(double th, int r_start, int r_end)
{
  int x_st, x_end, y_st, y_end;

  x_st  = WIN_WIDTH/2 + r_start * cos(th);
  x_end = WIN_WIDTH/2 + r_end * cos(th);
  y_st  = WIN_WIDTH/2 - r_start * sin(th);
  y_end = WIN_WIDTH/2 - r_end * sin(th);
  XDrawLine(disp, win, gc_a, x_st, y_st, x_end, y_end);
}

/* פΰվľ */
int drawFace(void)
{
  time_t     ti;
  struct tm  *now;
  char       msg[128];

  /* ߤλ */
  time(&ti);
  now = localtime(&ti);
  /* öɥäƤ */
  XClearWindow(disp, win);
  /* ʸפľ */
  XDrawArc(disp, win, gc_a,  0,  0,  99,  99, 0, 360*64);
  XDrawArc(disp, win, gc_a, 20, 20,  59,  59, 0, 360*64);
  XDrawArc(disp, win, gc_a, 30, 30,  39,  39, 0, 360*64);
  XDrawArc(disp, win, gc_a, 40, 40,  19,  19, 0, 360*64);
  /* ˤ */
  draw_hand(M_PI/2-(now->tm_hour)*2*M_PI/12, 10, 20);
  draw_hand(M_PI/2-(now->tm_min)*2*M_PI/60, 20, 30);
  draw_hand(M_PI/2-(now->tm_sec)*2*M_PI/60, 30, 50);
  /* 󲽤Υȥ */
  sprintf(msg, "xtokei - %02d:%02d",  now->tm_hour, now->tm_min);
  XSetIconName(disp, win, msg);
  /* եå夷Ƥ */
  XFlush(disp);
}

/* ʥȯθƤӽФؿ */
void redraw_win()
{
  /* 顼ॷʥ */
  if (signal(SIGALRM, redraw_win) == SIG_ERR) {
    perror("signal");
    exit(1);
  }
  /* ľ */
  drawFace();
  /* Υ顼 */
  alarm(ti);
}


int main(int argc, char *argv[])
{
  Pixmap  icon;
  XFontStruct  *f_a, *f_k;
  XEvent  evnt;
  XSetWindowAttributes  att;
  XWMHints  hint_stat;

  char  msg[128];
  char  msg_bln[64] = BALOON_MSG;
  int   idx = 1;

  /* ޥɥ饤󤫤ѥ᥿ */
  while (idx < argc) {
    /* إɽ */
    if (strcmp(argv[idx], "-h") == 0) {
      fprintf(stderr, "*** Tiny tokei.\n");
      fprintf(stderr, "Usage : %s [-update <seconds>] [baloon message in EUC]\n", argv[0]);
      fprintf(stderr, "options as follows:\n");
      fprintf(stderr, "  [-h]\n");
      fprintf(stderr, "  [-update <update seconds>]\n");
      fprintf(stderr, "see document for more informations, thanks.\n");
      exit(1);
    } else
    if (strcmp(argv[idx], "-update") == 0) {
      sscanf(argv[++idx], "%d", &ti);
    } else {
      strncpy(msg_bln, argv[idx], 64);
    }
    idx++;
  }

  /* ֳ֤̤ʤСäˤ */
  if (ti < 1) ti = 1;

  /* 顼ॷʥ */
  if (signal(SIGALRM, redraw_win) == SIG_ERR) {
    perror("signal");
    exit(1);
  }
  /* Υ顼 */
  alarm(ti);

  /* 饦ɥλϤޤ */
  disp = XOpenDisplay(NULL);
  /* 饤ȤȥХ롼Υɥߤ */
  win = XCreateSimpleWindow(disp, RootWindow(disp, 0),
          10, 900, WIN_WIDTH, WIN_HEIGHT, 2, BlackPixel(disp, 0), WhitePixel(disp, 0));
  baloon = XCreateSimpleWindow(disp, RootWindow(disp, 0),
          10, 110, BLN_WIDTH, BLN_HEIGHT, 1, BlackPixel(disp, 0), WhitePixel(disp, 0));

  /* Х롼󥦥ɥ˥ɥޥ͡㡼βߤᤵ */
  att.override_redirect = True;
  XChangeWindowAttributes(disp, baloon, CWOverrideRedirect, &att);
  /* ꡧܥ˽Ϫݥ󥿽 */
  XSelectInput(disp, win, ExposureMask | ButtonPressMask | EnterWindowMask | LeaveWindowMask | StructureNotifyMask);
  XSelectInput(disp, baloon, ExposureMask);
  /* եȤɤ߹ǡꤹ */
  /* ʪ碌ʤΤǡեȤѤˤϳƼѥ᥿Ѥɬפ */
  gc_a = XCreateGC(disp, RootWindow(disp, 0), 0, 0);
  gc_k = XCreateGC(disp, RootWindow(disp, 0), 0, 0);
  f_a = XLoadQueryFont(disp, ALPHA_FONT);
  f_k = XLoadQueryFont(disp, KANJI_FONT);
  XSetFont(disp, gc_a, f_a->fid);
  XSetFont(disp, gc_k, f_k->fid);

  /* Υѥɤ߹ߡԥåޥåפ */
  /* 夷եѹ顢碌ѹƲ */
  icon = XCreateBitmapFromData(disp, win, clk_icn_bits, clk_icn_width, clk_icn_height);
  /* ףͣȣ˥ꤹ */
  /* ˶ԥåޥåפꤷ */
  hint_stat.icon_pixmap = icon;
  /* ꤹޥꤷơ */
  hint_stat.flags = IconPixmapHint;
  /* ºݤ˥ɥޥ͡㡼Τ */
  XSetWMHints(disp, win, &hint_stat);
  /* ɥޥ͡㡼˥ȥΤ */
  XStoreName(disp, win, "xtokei");
  /* 롼ȤΣɥˤơǥ졼򲡤 */
  /* ʣǤϸ̵ */
  XSetTransientForHint(disp, win, RootWindow(disp, 0));
  /* ɥɽ */
  XMapWindow(disp, win);

  while (1) {
    XNextEvent(disp, &evnt);
    /* ޥܥ󲡲ǽλ */
    if (evnt.type == ButtonPress) 
      break;
    /* ɥ礭ѹǤ⡢᤹ */
    if (evnt.type == ConfigureNotify) 
      XResizeWindow(disp, win, WIN_WIDTH, WIN_HEIGHT);
    /* ɥϪФ顢 */
    if (evnt.type == Expose && evnt.xany.window == win) {
      drawFace();
    } else
    /* Х롼󡦥ɥƱͤ */
    if (evnt.type == Expose && evnt.xany.window == baloon) {
      drawStr(disp, baloon, gc_a, gc_k, f_a, f_k, 1, 16, (char *)msg_bln);
    } else
    /* ݥ󥿤ä顢Х롼ɽ */
    if (evnt.type == EnterNotify &&  evnt.xany.window == win) {
      XMoveWindow(disp, baloon, evnt.xcrossing.x_root+8, evnt.xcrossing.y_root-8);
      XMapRaised(disp, baloon);
    } else
    /* ݥ󥿤Ф顢Х롼ɽ */
    if (evnt.type == LeaveNotify && evnt.xany.window == win) {
        XUnmapWindow(disp, baloon);
    }
  }
  XCloseDisplay(disp);

}
